/* XPLog -- an PPP-Dialer and Phonecost Program
 * Copyright (C) 1998 Stefan Kraus
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */ 

#ifndef _XPLOG_H
#define _XPLOG_H

#include <iostream.h>
#include <string.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h> /* sleep execl */
#include <dirent.h>
#include <ctype.h>

#include <forms.h>

#include "language.h"


/* XPLog Binary */
#define XPLOG "/usr/local/bin/xplog &"
//#define XPLOG "/usr/X11/bin/xplog &"

/* Help-File */
#define XPHELP "/usr/local/bin/xplog.hlp"
//#define XPHELP "/usr/X11/bin/xplog.hlp"

/* XPLog runs in DebugMode 0 - Debug Off / 1 - Debug On */
#define DEBUG     0

#define PPP_PID "/var/run/ppp0.pid"
#define IPPPD_PID "/var/run/ipppd.ippp0.pid"
#define IPPP_PID "/var/run/ippp0.pid"
/*#define PPP_PID "/home/fish/test.pid"*/

/* Main-GUI definition */
typedef struct xplMainGui
{
   /* Form data */
   FL_FORM        *form;

   /* Event Loop */
   FL_OBJECT      *obj;
   int            ready;

   /* Last and Actual Fields */
   FL_OBJECT      *QPLovframe;
   FL_OBJECT      *QPLbegin,*QPLend,*QPLduration;
   FL_OBJECT      *QPLlbegin,*QPLlend,*QPLlduration;

   /* Control-Panel */
   FL_OBJECT      *QPLcframe;
   FL_OBJECT      *QPLconnect,*QPLlogfile,*QPLinfo,*QPLphonebill;
   FL_OBJECT      *QPLqframe,*QPLpref,*QPLquit,*QPLhelp;

   /* User Buttons */
   FL_OBJECT      *QPLusera,*QPLuserb,*QPLuserc;
} xplMainGui;

/* ViewError GUI definition */
typedef struct xplViewError
{
   /* Form data */
   FL_FORM        *form;

   /* Event Loop */
   FL_OBJECT      *obj;
   int            ready;

   /* draw Frame */
   FL_OBJECT      *viewfield;
   FL_OBJECT      *QPLframe,*QPLexit;
} xplViewError;

/* ViewLog GUI definition */
typedef struct xplViewLog
{
   /* Form data */
   FL_FORM        *form;

   /* Event Loop */
   FL_OBJECT      *obj;
   int            ready;

   /* draw Frame */
   FL_OBJECT      *viewfield;
   FL_OBJECT      *QPLframe,*QPLexit;
   FL_OBJECT      *QPLbegin,*QPLend;

   /* extendet Buttons */
   FL_OBJECT      *QPLsave,*QPLdelete,*QPLdown,*QPLup;
} xplViewLog;

/* PhoneBill GUI definition */
typedef struct xplPhoneBill
{
   /* Form data */
   FL_FORM        *form;

   /* Event Loop */
   FL_OBJECT      *obj;
   int            ready;
  
   /* Calender Buttons */
   FL_OBJECT      *QPLcalframea,*QPLmontha,*QPLmontham,*QPLmonthap,*QPLjeara,*QPLdaya[7],*QPLcala[32];
   FL_OBJECT      *QPLcalframeb,*QPLmonthb,*QPLmonthbm,*QPLmonthbp,*QPLjearb,*QPLdayb[7],*QPLcalb[32];
   /* Chart-Graphic */
   FL_OBJECT      *chart,*QPLstatframe,*QPLyear;
   /* draw Frame */
   FL_OBJECT      *viewfield;

   FL_OBJECT      *QPLframe,*QPLcalc,*QPLview,*QPLexit;

   /* Statistic Selection */
   FL_OBJECT      *QPLonline,*QPLcost,*QPLstat;
   FL_OBJECT      *QPLsnapfr,*QPLsnapshot;
} xplPhoneBill;

/* Pref GUI definition */
typedef struct xplPref
{
   /* Form data */
   FL_FORM        *form;

   /* Event Loop */
   FL_OBJECT      *obj;
   int            ready;

   /* Window-Position */
   FL_OBJECT      *QPLposition,*QPLlo,*QPLro,*QPLlu,*QPLru,*QPLcenter;
   /* Script Sektion */
   FL_OBJECT      *QPLscript,*QPLprovider,*QPLpppon,*QPLpppoff,*QPLselon,*QPLseloff;
   FL_OBJECT      *QPLbar,*QPLdeal;
   /* User Buttons */
   FL_OBJECT      *QPLfuser,*QPLusera,*QPLuseraa,*QPLuserb,*QPLuserbb,*QPLuserc,*QPLusercc;
   FL_OBJECT      *QPLsela,*QPLselb,*QPLselc;
   /* Basic Rates */
   FL_OBJECT      *QPLbrate,*QPLbasicrate,*QPLprent,*QPLcredit;
   /* Options */
   FL_OBJECT      *QPLfxframe,*QPLpp,*QPLoplogfile,*QPLguia,*QPLguib,*QPLguic,*QPLmess,*QPLmanual;
   FL_OBJECT      *QPLicon,*QPLfreemove,*QPLnoredial;

   /* LogFile Converter - Messages -> .xplog.log */
   FL_OBJECT      *QPLlcframe,*QPLconvert;

   /* Deal Protection */
   FL_OBJECT      *QPLprotectf,*QPLprotect;
   
   /* Control Panel */
   FL_OBJECT      *QPLcontrol,*QPLsave,*QPLsaveexit,*QPLexit,*QPLhelp;

   /* Rate Panel */
   FL_OBJECT      *QPLrateframe,*QPLclear,*QPLrates,*QPLhour[12],*QPLmin[12],*QPLtakt[12],*QPLprice[12],*QPLrinfo;
   FL_OBJECT      *QPLweekday[8],*QPLjoin,*QPLcut,*QPLcopy,*QPLpaste,*QPLimport,*QPLexport;
} xplPref;

/* Supported Deal Programms GUI definition */
typedef struct xplDealPrg
{
   /* Form data */
   FL_FORM        *form;

   /* Event Loop */
   FL_OBJECT      *obj;
   int            ready;

   /* draw Frame */
   FL_OBJECT      *viewfield;
   FL_OBJECT      *QPLframe,*QPLexit;
} xplDealPrg;

/* Get Rates GUI definition */
typedef struct xplGetRates
{
   /* Form data */
   FL_FORM        *form;

   /* Event Loop */
   FL_OBJECT      *obj;
   int            ready;

   /* draw Frame */
   FL_OBJECT      *viewfield;
   FL_OBJECT      *QPLframe,*QPLexit;
} xplGetRates;

/* LogFile Convert GUI definition */
typedef struct xplLFConvert
{
   /* Form data */
   FL_FORM        *form;

   /* Event Loop */
   FL_OBJECT      *obj;
   int            ready;

   /* draw Frame */
   FL_OBJECT      *viewfield;
   FL_OBJECT      *QPLstatframe,*QPLframe,*QPLjear,*QPLimport,*QPLexit,*QPLdellog;
} xplLFConvert;

/* RatesInfo GUI definition */
typedef struct xplRatesInfo
{
   /* Form data */
   FL_FORM        *form;

   /* Event Loop */
   FL_OBJECT      *obj;
   int            ready;
  
   /* draw Frame */
   FL_OBJECT      *viewfield;
   FL_OBJECT      *QPLexit;

   /* Frame GUI */
   FL_OBJECT      *QPLTime[28],*QPLbar[16];

   /* Su - Sa 30 */
   FL_OBJECT      *QPLsua[28],*QPLmoa[28],*QPLtua[28],*QPLwea[28],*QPLtha[28],*QPLfra[28],*QPLsaa[28];
   /* Su - Sa 60 */
   FL_OBJECT      *QPLsub[28],*QPLmob[28],*QPLtub[28],*QPLweb[28],*QPLthb[28],*QPLfrb[28],*QPLsab[28];
} xplRatesInfo;

/* Deal Protection */
typedef struct xplDealProt
{
   /* Form data */
   FL_FORM        *form;

   /* Event Loop */
   FL_OBJECT      *obj;
   int            ready;
  
   /* draw Frame */
   FL_OBJECT      *viewfield;
   FL_OBJECT      *QPLframe;
   FL_OBJECT      *QPLexit;

   /* Timebar */
   FL_OBJECT      *QPLTimeA[24],*QPLTimeB[24];
   
   /* Daybar */
   FL_OBJECT      *QPLbarA[7],*QPLbarB[7];

   /* Su - Sa */
   FL_OBJECT      *QPLsu[24],*QPLmo[24],*QPLtu[24],*QPLwe[24],*QPLth[24],*QPLfr[24],*QPLsa[24];

   int            aa,bb;

} xplDealProt;  

/* Preferences File Format */
typedef struct xplog
{
   /* Window Position */
   int            winpos;
   /* PPP-Connect/Disconnect */
   char           provider[255];
   char           pppstart[255];
   char           pppstop[255];
   /* User Buttons */ 
   char           usera[20];
   char           useraa[255];
   char           userb[20];
   char           userbb[255];
   char           userc[20];
   char           usercc[255];
   /* Rates */
   int            xpqh[92];
   int            xpqm[92];
   float          xpqr[92];
   float          xpqc[92];
   float          xpqt[92];
   /* Phonebill-Protocol */
   int            PBProt;
   /* View Phonebill-Protocol */
   int            PBView;
   /* Basic Rates */
   float          xpbr;
   float          xprent;
   float          xpcredit;
   /* Alternative GUI */
   int            xpgui;
   /* Disable Messages */
   int            xpmess;
   /* Manual Rates Registration */ 
   int            xpmanual; 
   /* Free Window Position */
   int            FreeMove;
   int            xpos;
   int            ypos;
   int            xborder;
   int            yborder;
   /* Iconify */
   int            iconify;
   /* No ReDial */
   int            noredial;
   /* Deal Protection */
   char           xpDP[7][24];
} xplog;

/* Import/Export Rates Table */
typedef struct iedata {
   /* Rates */
   int            xieh[92];
   int            xiem[92];
   float          xier[92];
   float          xiec[92];
   float          xiet[92];
} iedata;

/* 
   main.c 
*/
void Viewerror(int bug);
/* 
   calc.c
*/
float phcalc(long atime,long btime);
float wdaycalc(int weekday,int hourb,int minb,int secb,int houre,int mine,int sece);
float phonecalc(int dayb,int monthb,int jearb,int hourb,int minb,int secb,int daye,int monthe,int jeare,int houre,int mine,int sece);
/* 
   logview.c
*/
void Viewlog(void);
void Viewcost(void);
void Viewstat(void);
void Viewhelp(void);
void Viewsnap(void);
void Viewer(int mo,int ab,char *txt);
/*
   phonebill.c
*/
void phonebill(void);
/* calculation */
void pbcalc(void);
int docal(int d,int c,int a,int b);
void calclear(int a);
void statistic(int a);
/* load SNAP-File */
void loadsnap(void);
/*
   pref.c
*/
void Pref(void);
void initrates(void);
void setweekday(int a);
void DealPrg(void);
void getrates(void);
void lfconvert(void);
/* Export Rates Datas */
void exportrates(void);
/* Import Rates Datas */
void importrates(void);
/* Check Deal Protection */
int CheckProtection(long atime);
/*
   ratesinfo.c
*/
/* Viewer */
void ratesinfo(void);
/*
   protect.c
*/
/* ProtectEditor */
void ProtectEd(int mo);
/* Display Deal Protection */
void ViewProtection(void);
/*
   standart.c
*/
/* System Funktionen & Erweiterungen */
void newSleep(int delay);
/* Datenkonvertieren */
const char *IntStr(int a);
const char *DoubleStr(float a);
int IRound(float a);
/* Stringverarbeitung */
const char *LStr(char *source,int a);
const char *RStr(char *source,int a);
const char *strMids(char *source,int a,int b);
const char *strTrim(char *source);
void strNewTrim(char *source);
const char *strNoRem(char *source,char *rem);
const char *strGetFirst(char *source);
const char *strDelFirst(char *source);
const char *strGetParm(char *source);
const char *strDelParm(char *source);
const char *strUpper(char *source);
void strNewUpper(char *source);
const char *strInsert(char *source1,int a, char *source2);
/* Zeitrelevante Funktionen */
const char *strDiffTime(long a,long b);
const char *strDiff(long aa);
const char *strDate(char *source,int year);

int monthLen(int a,int b);
int daysBetwin(int a,int b,int c,int d,int e,int f);
int getDay(int c,int a,int b);

#endif
